

MACRO(BBTK_CREATE_PACKAGE_INCLUDE_SCRIPT    BBTK_PACKAGE_NAME    BBTK_PACKAGE_BBS_BOXES    BBTK_PACKAGE_BBS_APPLI )

  # Creates the file ${BBTK_PACKAGE_NAME}.bbp
  SET(OUTPUT_FILE ${BBTK_BBS_BUILD_PATH}/${BBTK_PACKAGE_NAME}.bbp)
  FILE(WRITE 
    "${OUTPUT_FILE}" 
    "#-----------------------------------------\n"
    "# Include script for bbtk package '${BBTK_PACKAGE_NAME}'\n"
    "# Automatically generated by cmake (macro BBTK_CREATE_PACKAGE_INCLUDE_SCRIPT)\n")
  FILE(APPEND 
    "${OUTPUT_FILE}"
    "#-----------------------------------------\n"
    "load ${BBTK_PACKAGE_NAME}\n"
    "#-----------------------------------------\n"
    "package ${BBTK_PACKAGE_NAME}\n"
    )
  
  #FILE(APPEND 
  #  "${OUTPUT_FILE}"
  #  "#-----------------------------------------\n"
  #  "include ${BBTK_PACKAGE_NAME}/boxes/*\n"
  #  )
  
  FOREACH(bbs ${BBTK_PACKAGE_BBS_BOXES})  
    FILE(APPEND 
      "${OUTPUT_FILE}"
      "#-----------------------------------------\n"
      "include ${BBTK_PACKAGE_NAME}/${bbs}\n"
      )
    CONFIGURE_FILE(
      ${CMAKE_CURRENT_SOURCE_DIR}/${bbs}
      ${BBTK_BBS_BUILD_PATH}/${BBTK_PACKAGE_NAME}/${bbs}
      COPYONLY
      )
    GET_FILENAME_COMPONENT(bbs_path ${bbs} PATH)
    
    
    IF(WIN32)
    INSTALL(
      FILES ${CMAKE_CURRENT_SOURCE_DIR}/${bbs}
#      DESTINATION ${BBTK_BBS_INSTALL_PATH}/${BBTK_PACKAGE_NAME}/${bbs_path}
      DESTINATION ${BBTK_BBS_REL_PATH}/${BBTK_PACKAGE_NAME}/${bbs_path}
    )
ELSE(WIN32)
INSTALL(
      FILES ${CMAKE_CURRENT_SOURCE_DIR}/${bbs}
      DESTINATION ${BBTK_BBS_INSTALL_PATH}/${BBTK_PACKAGE_NAME}/${bbs_path}
#      DESTINATION ${BBTK_BBS_REL_PATH}/${BBTK_PACKAGE_NAME}/${bbs_path}
    )
ENDIF(WIN32)
  ENDFOREACH(bbs)
  FILE(APPEND 
    "${OUTPUT_FILE}"
      "#-----------------------------------------\n"
      "endpackage\n"
      "#-- EOF ----------------------------------\n"
    )
 IF(WIN32)
  INSTALL(
    FILES ${OUTPUT_FILE}
#    DESTINATION ${BBTK_BBS_INSTALL_PATH}
    DESTINATION ${BBTK_BBS_REL_PATH}
    )
ELSE(WIN32)
  INSTALL(
    FILES ${OUTPUT_FILE}
    DESTINATION ${BBTK_BBS_INSTALL_PATH}
#   DESTINATION ${BBTK_BBS_REL_PATH}
    )
ENDIF(WIN32)
  # Creates the file ${BBTK_PACKAGE_NAME}-appli.bbp
  SET(OUTPUT_FILE ${BBTK_BBS_BUILD_PATH}/${BBTK_PACKAGE_NAME}-appli.bbp)
  FILE(WRITE 
    "${OUTPUT_FILE}" 
    "#-----------------------------------------\n"
    "# Applications include script for bbtk package '${BBTK_PACKAGE_NAME}'\n"
    "# Automatically generated by cmake (macro BBTK_CREATE_PACKAGE_INCLUDE_SCRIPT)\n")
  FILE(APPEND 
    "${OUTPUT_FILE}"
    "#-----------------------------------------\n"
    "load ${BBTK_PACKAGE_NAME}\n"
    "#-----------------------------------------\n"
    "package ${BBTK_PACKAGE_NAME}\n"
    )
  FOREACH(bbs ${BBTK_PACKAGE_BBS_APPLI})  
    GET_FILENAME_COMPONENT(filename "${bbs}" NAME_WE) 
    FILE(APPEND 
      "${OUTPUT_FILE}"
      "#-----------------------------------------\n"
      "define ${filename}\n"
      "include ${BBTK_PACKAGE_NAME}/${bbs} source\n"
      "endefine\n"
      )
    CONFIGURE_FILE(
      ${CMAKE_CURRENT_SOURCE_DIR}/${bbs}
      ${BBTK_BBS_BUILD_PATH}/${BBTK_PACKAGE_NAME}/${bbs}
      COPYONLY
      )
    GET_FILENAME_COMPONENT(bbs_path ${bbs} PATH)
    
    
    IF(WIN32)
    INSTALL(
      FILES ${CMAKE_CURRENT_SOURCE_DIR}/${bbs}
  #    DESTINATION ${BBTK_BBS_INSTALL_PATH}/${BBTK_PACKAGE_NAME}/${bbs_path}
      DESTINATION ${BBTK_BBS_REL_PATH}/${BBTK_PACKAGE_NAME}/${bbs_path}
      )
ELSE(WIN32)
    INSTALL(
      FILES ${CMAKE_CURRENT_SOURCE_DIR}/${bbs}
      DESTINATION ${BBTK_BBS_INSTALL_PATH}/${BBTK_PACKAGE_NAME}/${bbs_path}
  #    DESTINATION ${BBTK_BBS_REL_PATH}/${BBTK_PACKAGE_NAME}/${bbs_path}
      )
ENDIF(WIN32)
  ENDFOREACH(bbs)
  FILE(APPEND 
    "${OUTPUT_FILE}"
      "#-----------------------------------------\n"
      "endpackage\n"
      "#-- EOF ----------------------------------\n"
    )
IF(WIN32)  
  INSTALL(
    FILES ${OUTPUT_FILE}
   # DESTINATION ${BBTK_BBS_INSTALL_PATH}
    DESTINATION ${BBTK_BBS_REL_PATH}
    )
ELSE(WIN32)  
  INSTALL(
    FILES ${OUTPUT_FILE}
    DESTINATION ${BBTK_BBS_INSTALL_PATH}
   # DESTINATION ${BBTK_BBS_REL_PATH}
    )
ENDIF(WIN32)  
#  ADD_CUSTOM_TARGET(${BBTK_PACKAGE_NAME}.bbp ALL
#    DEPENDS  ${OUTPUT_FILE}
#    )


ENDMACRO(BBTK_CREATE_PACKAGE_INCLUDE_SCRIPT)
