
#-----------------------------------------------------------------------------
MESSAGE ( STATUS "")
MESSAGE ( STATUS "=======================================")
MESSAGE ( STATUS "     LOOKING FOR LIBRARIES NEEDED")
MESSAGE ( STATUS "=======================================")
MESSAGE ( STATUS "")
#-----------------------------------------------------------------------------
  
#-----------------------------------------------------------------------------
# 11/12/08 : BBTK IS NOW BASED ON crea
SET(CREA_VERBOSE_CMAKE TRUE)
FIND_PACKAGE(crea REQUIRED)
IF (crea_FOUND)
  INCLUDE(${crea_USE_FILE})
ENDIF(crea_FOUND)
#-----------------------------------------------------------------------------


#-----------------------------------------------------------------------------
# USE SHIPPED BOOST ?
IF(BBTK_USE_SHIPPED_BOOST)
  MESSAGE ( STATUS "=======================================")
  MESSAGE(STATUS "bbtk uses shipped boost C++ library (${BBTK_SHIPPED_BOOST})")
  INCLUDE_DIRECTORIES( 
    ${PROJECT_SOURCE_DIR}/kernel/src/ThirdParty/${BBTK_SHIPPED_BOOST})

  # TO DO : CLEANLY BLOCK auto_link.hpp INCLUSION 
  #CREA_DEFINE(BOOST_SIGNALS_NO_LIB)
  SET(BBTK_BOOST_LIBRARIES
    bbtk_boost_signals
    )  
  
ELSE(BBTK_USE_SHIPPED_BOOST)
  SET(USE_BOOST ON CACHE BOOL "Use boost C++ library" FORCE)
  SET(BBTK_BOOST_LIBRARIES
    boost_signals
    )
ENDIF(BBTK_USE_SHIPPED_BOOST)
#-----------------------------------------------------------------------------




#-----------------------------------------------------------------------------
CREA_FIND_AND_USE_LIBRARIES()
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
MESSAGE(STATUS "=======================================")
MESSAGE(STATUS "")
MESSAGE(STATUS "=======================================")
MESSAGE(STATUS "   ... ALL NEEDED LIBRARIES FOUND")
MESSAGE(STATUS "=======================================")
MESSAGE(STATUS "")
#-----------------------------------------------------------------------------


#-----------------------------------------------------------------------------
# bbtk library dependencies
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# WXWIDGETS
IF(BBTK_USE_WXWIDGETS)
  SET(BBTK_LINK_LIBRARIES
    ${BBTK_LINK_LIBRARIES}
    ${WXWIDGETS_LIBRARIES} 
    )
ENDIF(BBTK_USE_WXWIDGETS)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# KWWIDGETS
IF(BBTK_USE_KWWIDGETS)
  SET(BBTK_LINK_LIBRARIES
    ${BBTK_LINK_LIBRARIES}
    ${KWWIDGETS_LIBRARIES} 
    )
ENDIF(BBTK_USE_KWWIDGETS)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# BOOST 
SET(BBTK_LINK_LIBRARIES
  ${BBTK_LINK_LIBRARIES}
  ${BBTK_BOOST_LIBRARIES} 
  ) 
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# On unix systems, need to link against dl for dynamic librairies open/close
IF(UNIX)
  SET(BBTK_LINK_LIBRARIES
    ${BBTK_LINK_LIBRARIES}
    dl) 
ENDIF(UNIX)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
MESSAGE(STATUS "")
MESSAGE(STATUS "=======================================")
MESSAGE(STATUS "bbtk LINK LIBRARIES:")
MESSAGE(STATUS "${BBTK_LINK_LIBRARIES}")
MESSAGE(STATUS "=======================================")
MESSAGE(STATUS "")
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# EO bbtk library dependencies
#-----------------------------------------------------------------------------

