/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbtkComplexBlackBoxInputDescriptor.cxx,v $
  Language:  C++
  Date:      $Date: 2008/10/17 08:18:12 $
  Version:   $Revision: 1.5 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


/**
 *  \file 
 *  \brief Class bbtk::ComplexBlackBoxInputDescriptor : structure containing the description of a ComplexBlackBox input (name, description, type, mapping)
 */
#include "bbtkComplexBlackBoxInputDescriptor.h"
   

namespace bbtk
{

  
  ComplexBlackBoxInputDescriptor::
  ComplexBlackBoxInputDescriptor( TypeInfo creator_type_info,
				  const std::string& name,
				  const std::string& description,
				  const std::string& nature,
				  const std::string& target,
				  const std::string& input,
				  TypeInfo type)			
    : 
    BlackBoxInputDescriptor(creator_type_info,name,description,nature),
    mTarget(target),
    mInput(input),
    mType(type)
  {    
    
    bbtkDebugMessage("Kernel",9,"ComplexBlackBoxInputDescriptor::ComplexBlackBoxInputDescriptor(\""<<name<<"\",\""<<description<<"\",\""<<target<<"\",\""<<input<<"\")"<<std::endl);
  }
  

  ComplexBlackBoxInputDescriptor::~ComplexBlackBoxInputDescriptor() 
  {
    bbtkDebugMessage("Kernel",9,"ComplexBlackBoxInputDescriptor::~ComplexBlackBoxInputDescriptor(\""<<GetName()<<"\",\""<<GetDescription()<<"\",\""<<GetTarget()<<"\",\""<<GetInput()<<"\")"<<std::endl);
  }
  
}
