/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbstdASCII.h,v $
  Language:  C++
  Date:      $Date: 2008/12/11 15:30:09 $
  Version:   $Revision: 1.9 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


#ifndef __bbstdASCII_h_INCLUDED__
#define __bbstdASCII_h_INCLUDED__
#include "bbtkAtomicBlackBox.h"
#include "bbstd_EXPORT.h"
#include "iostream"

namespace bbstd
{

  class bbstd_EXPORT ASCII
    : 
    public bbtk::AtomicBlackBox
  {
    BBTK_BLACK_BOX_INTERFACE(ASCII,bbtk::AtomicBlackBox);
    //==================================================================
    /// User callback called in the box contructor
    virtual void bbUserConstructor();
    /// User callback called in the box copy constructor
    virtual void bbUserCopyConstructor(bbtk::BlackBox::Pointer);
    /// User callback called in the box destructor
    virtual void bbUserDestructor();
    //==================================================================
    BBTK_DECLARE_INPUT(In,std::string);
    BBTK_DECLARE_INPUT(Type,int);
    BBTK_DECLARE_OUTPUT(Out,std::string);
    BBTK_PROCESS(Process);
    void Process();
  };
  
  BBTK_BEGIN_DESCRIBE_BLACK_BOX(ASCII,bbtk::AtomicBlackBox);
  BBTK_NAME("ASCII");  
  BBTK_AUTHOR("eduardo.davila [at] creatis [dot] insa-lyon.fr");

  BBTK_DESCRIPTION("ascii codes sequence to string - string to ascii codes sequence");
  BBTK_CATEGORY("misc");
  BBTK_INPUT(ASCII,In,   "Ascii code or Ascii character",                                               std::string,"");
  BBTK_INPUT(ASCII,Type, "Conversion type (default 0) 0=Ascii codes to string, 1=String to ascii codes",int,"");
  BBTK_OUTPUT(ASCII,Out, "Ascii codes sequence or characters sequence",                                 std::string,"");
  BBTK_END_DESCRIBE_BLACK_BOX(ASCII);

}
// EO namespace bbstd

#endif // __bbstdASCII_h_INCLUDED__

