/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbstdExecSystemCommand.h,v $
  Language:  C++
  Date:      $Date: 2008/12/12 08:55:21 $
  Version:   $Revision: 1.6 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


#ifndef __bbstdExecSystemCommand_h_INCLUDED__
#define __bbstdExecSystemCommand_h_INCLUDED__

#include "bbtkAtomicBlackBox.h"
#include "bbstd_EXPORT.h"

namespace bbstd
{

  class bbstd_EXPORT ExecSystemCommand
    : 
  public bbtk::AtomicBlackBox
  {
  public:
    BBTK_BLACK_BOX_INTERFACE(ExecSystemCommand,bbtk::AtomicBlackBox);
    BBTK_DECLARE_INPUT(In,std::string)
    BBTK_PROCESS(DoProcess);
    void DoProcess();

  protected:
    virtual void bbUserConstructor();
  };

  BBTK_BEGIN_DESCRIBE_BLACK_BOX(ExecSystemCommand,bbtk::AtomicBlackBox);
  BBTK_NAME("ExecSystemCommand");
  BBTK_AUTHOR("eduardo.davila@creatis.insa-lyon.fr");
  BBTK_DESCRIPTION("Executes system (O.S.) commands");
  BBTK_INPUT(ExecSystemCommand,In,"system (O.S.) commands separated by ';' , use '' to indicate strings ex. help 'graph' ",std::string,"");  
  BBTK_END_DESCRIBE_BLACK_BOX(ExecSystemCommand);

} // EO namespace bbstd

#endif //  __bbstdExecSystemCommand_h_INCLUDED__


