/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbstdStringTo.h,v $
  Language:  C++
  Date:      $Date: 2008/12/12 08:55:21 $
  Version:   $Revision: 1.7 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


#ifndef __bbstdStringTo_h_INCLUDED__
#define __bbstdStringTo_h_INCLUDED__

#include "bbtkAtomicBlackBox.h"
#include "bbstd_EXPORT.h"

namespace bbstd 
{ 
  //=================================================================
  // BlackBox declaration
  template <class T>
  class bbstd_EXPORT StringTo : public bbtk::AtomicBlackBox
  {  
    BBTK_TEMPLATE_BLACK_BOX_INTERFACE(StringTo,bbtk::AtomicBlackBox,T);
    BBTK_DECLARE_INPUT(In,std::string);
    BBTK_DECLARE_OUTPUT(Out,T);
    BBTK_PROCESS(DoIt);
    void DoIt(); 
  };
  //=================================================================

  //=================================================================  
  // BlackBox description
  BBTK_BEGIN_DESCRIBE_TEMPLATE_BLACK_BOX(StringTo,bbtk::AtomicBlackBox);
  BBTK_NAME("StringTo"+bbtk::HumanTypeName<T>());
  BBTK_AUTHOR("laurent.guigues@creatis.insa-lyon.fr");
  BBTK_DEFAULT_ADAPTOR();
  BBTK_DESCRIPTION("Converts the content of the input string to a "
		   +bbtk::HumanTypeName<T>()
		   +" ("+bbtk::TypeName<T>()+")");
  BBTK_TEMPLATE_INPUT(StringTo, In,"Input",std::string);
  BBTK_TEMPLATE_OUTPUT(StringTo, Out,"Output",T);
  BBTK_END_DESCRIBE_TEMPLATE_BLACK_BOX(StringTo);
  //=================================================================
  
} // namespace bbstd

#endif // __bbstdStringTo_h_INCLUDED__
