#ifndef __bbvtkVecIsoSurfaceExtractor_h_INCLUDED__
#define __bbvtkVecIsoSurfaceExtractor_h_INCLUDED__
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkImageData.h"
#include "vtkRenderer.h"
#include "vtkMarchingCubes.h"
#include "vtkPolyDataMapper.h"
#include "vtkProp3D.h"
#include "vtkActor.h"
#include <vector>


namespace bbvtk
{

class /*BBTK_EXPORT*/ VecIsoSurfaceExtractor
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(VecIsoSurfaceExtractor,bbtk::AtomicBlackBox);
//==================================================================
/// User callback called in the box contructor
virtual void bbUserConstructor();
/// User callback called in the box copy constructor
virtual void bbUserCopyConstructor(bbtk::BlackBox::Pointer);
/// User callback called in the box destructor
virtual void bbUserDestructor();
//==================================================================
    BBTK_DECLARE_INPUT(In,std::vector<vtkImageData*>);
    //    BBTK_DECLARE_INPUT(InVtkObject,vtkObject *);
    BBTK_DECLARE_INPUT(Isovalue,double);
    BBTK_DECLARE_INPUT(Opacity,double);
    BBTK_DECLARE_INPUT(Colour,std::vector<double>);
    BBTK_DECLARE_INPUT(Renderer,vtkRenderer *);
	BBTK_DECLARE_INPUT(Transform, vtkLinearTransform *);
    BBTK_DECLARE_OUTPUT(Out,std::vector<vtkProp3D*>);
  BBTK_PROCESS(Process);
  void Process();

//	virtual void bbUserConstructor();
//	virtual void bbUserCopyConstructor();
//	virtual void bbUserDestructor();
	void Init();

  std::vector<vtkMarchingCubes*>	VecMarchingcubes;
  std::vector<vtkPolyDataMapper*>	VecPolydatamapper;
  std::vector<vtkProp3D*>			VecVtkactor; 

};

BBTK_BEGIN_DESCRIBE_BLACK_BOX(VecIsoSurfaceExtractor,bbtk::AtomicBlackBox);
BBTK_NAME("VecIsoSurfaceExtractor");
BBTK_AUTHOR("InfoTeam CREATIS-LRMN");
BBTK_DESCRIPTION("Vector of IsoSurfaceExtractor");
  BBTK_CATEGORY("3D object creator");
  BBTK_INPUT(VecIsoSurfaceExtractor,In,"Input image",std::vector<vtkImageData*>,"");
  //  BBTK_INPUT(IsoSurfaceExtractor,InVtkObject,"Image vtkObject",vtkObject*);
  BBTK_INPUT(VecIsoSurfaceExtractor,Isovalue,"Isovalue",double,"");
  BBTK_INPUT(VecIsoSurfaceExtractor,Opacity,"Opacity",double,"");
  BBTK_INPUT(VecIsoSurfaceExtractor,Colour,"r g b",std::vector<double>,"colour");
  BBTK_INPUT(VecIsoSurfaceExtractor,Renderer,"3D scene in which to insert the surface",vtkRenderer*,"");
  BBTK_INPUT(VecIsoSurfaceExtractor,Transform,"Linear Transform (4x4 homogeneous)",vtkLinearTransform*,"");
  BBTK_OUTPUT(VecIsoSurfaceExtractor,Out,"Extracted iso-surface",std::vector<vtkProp3D*>,"");
BBTK_END_DESCRIBE_BLACK_BOX(VecIsoSurfaceExtractor);
}
// EO namespace bbvtk

#endif // __bbvtkVecIsoSurfaceExtractor_h_INCLUDED__

