/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbwxLayoutTab.cxx,v $
  Language:  C++
  Date:      $Date: 2008/11/26 12:18:32 $
  Version:   $Revision: 1.9 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         

/**
 *  \file 
 *  \brief 
 */


#ifdef _USE_WXWIDGETS_


#include "bbwxLayoutTab.h"
#include "bbwxPackage.h"
#include "bbtkUtilities.h"




namespace bbwx
{
  BBTK_ADD_BLACK_BOX_TO_PACKAGE(wx , LayoutTab);
  

  BBTK_BLACK_BOX_IMPLEMENTATION(LayoutTab,bbtk::WxBlackBox);
  
	void LayoutTab::bbUserConstructor() 
	{ 
		bbSetInputOrientation("TOP");
		bbSetInputWidget1(NULL);
		bbSetInputWidget2(NULL);
		bbSetInputWidget3(NULL);
		bbSetInputWidget4(NULL);
		bbSetInputWidget5(NULL);
		bbSetInputWidget6(NULL);
		bbSetInputWidget7(NULL);
		bbSetInputWidget8(NULL);
		bbSetInputWidget9(NULL);
	}

  void LayoutTab::TryInsertWindow(wxNotebook *book, const std::string& input )
  {
    wxWindow* w = bbCreateWidgetOfInput(input,book); //panel);
    if (w!=NULL)
      {
	book->AddPage(w,w->GetName());
      }
  }

  void LayoutTab::Process() 
  { 
  }
  
  
  void LayoutTab::CreateWidget(wxWindow* parent) 
  { 
    long style = wxNB_TOP;
    if (bbtk::Utilities::loosematch(bbGetInputOrientation(),"0|T|TOP")==true) 
      { style=wxNB_TOP; }
    if (bbtk::Utilities::loosematch(bbGetInputOrientation(),"1|R|RIGHT")==true)
      { style=wxNB_RIGHT; }
    if (bbtk::Utilities::loosematch(bbGetInputOrientation(),"2|B|BOTTOM")==true)
      { style=wxNB_BOTTOM; }
    if (bbtk::Utilities::loosematch(bbGetInputOrientation(),"3|L|LEFT")==true)
      { style=wxNB_LEFT; }
    wxNotebook *w = new wxNotebook(parent, //bbGetWxParent(),
				   -1, 
				   wxDefaultPosition,
				   wxDefaultSize,
				   style );
    w->SetName( bbtk::std2wx( bbGetInputWinTitle() ) );
    
    TryInsertWindow(w,"Widget1");
    TryInsertWindow(w,"Widget2");
    TryInsertWindow(w,"Widget3");
    TryInsertWindow(w,"Widget4");
    TryInsertWindow(w,"Widget5");
    TryInsertWindow(w,"Widget6");
    TryInsertWindow(w,"Widget7");
    TryInsertWindow(w,"Widget8");
    TryInsertWindow(w,"Widget9");
    
    bbSetOutputWidget( w );
  }
  
  
  // This callback is necessary to get actual processing of the view 
  // when window is shown
  void  LayoutTab::OnShowWidget()
  {
    //bbGetOutputWidget()->Show();
    wxNotebook* w = (wxNotebook*)bbGetOutputWidget();
    if (w) 
      {
	if (w->GetPageCount()>0)
	  {
	    w->SetSelection(0);
	    for (unsigned int i=0; i<w->GetPageCount(); ++i)  w->AdvanceSelection();
	  }
	bbUserOnShowWidget("Widget1");
	bbUserOnShowWidget("Widget2");
	bbUserOnShowWidget("Widget3");
	bbUserOnShowWidget("Widget4");
	bbUserOnShowWidget("Widget5");
	bbUserOnShowWidget("Widget6");
	bbUserOnShowWidget("Widget7");
	bbUserOnShowWidget("Widget8");
	bbUserOnShowWidget("Widget9");
      }
    
   
  }


}//namespace bbwx

#endif

